=== debian/changelog ===
openmw (0.46.0-3) unstable; urgency=medium

  * Team upload.
  * Source-only upload to unstable.

 -- Tobias Frost <tobi@debian.org>  Sat, 23 Jan 2021 09:11:11 +0100

openmw (0.46.0-2) experimental; urgency=low

  * Applied armel and mipsel compile fixes from Andrian Bunk (Closes: #962874)
  * Transition from contrib to main (Closes: #963710)
  * Transition maintainership to the Debian Games Team
  * Updated uploaders field
  * Updated SV
  * Updated Package descriptions
  * Updated debian/license

 -- Bret Curtis <psi29a@gmail.com>  Mon, 18 Jan 2021 08:15:09 +0200

openmw (0.46.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add .gitlab-ci.yml
  * Fix FTBFS against boost_1.74. (Closes: #977226)

 -- Anton Gladky <gladk@debian.org>  Wed, 16 Dec 2020 23:25:18 +0100

openmw (0.46.0-1) unstable; urgency=low

  [ Bret Curtis ]
  * Upstream release: OpenMW-0.46.0 (Closes: #958917, #961536)
  * Adjusted dep to use opensceneraph-3.4 if found, otherwise use
    openscenegraph >= 3.6.5 because earlier versions are broken.

 -- Bret Curtis <psi29a@gmail.com>  Tue, 09 Jun 2020 08:15:09 +0200
